<template>
  <div class="">
    <toolbar @on-filter="filterData" @on-reset="filterData" />

    <div class="m-10 bg-w p-20 br-10">
      <el-button type="primary" icon="el-icon-plus" @click="handleAdd"
        >新增</el-button
      >
      <base-table
        :columns="columns"
        :items="items"
        :pagination="pagination"
        :page-change="pageChange"
        :showPage="false"
      />
    </div>
  </div>
</template>

<script>
import toolbar from './toolbar';
import mxFilterList from '@/mixins/filterList';
import { getPage, delItem } from '@/api/base/trend';

export default {
  name: 'Trending',

  components: { toolbar },

  mixins: [
    mxFilterList({
      fetchList: getPage, // 在下方data再声明一个 fetchList: iGetList 同等效果
      pagination: {
        page: 1,
        total: 0,
        pageSize: 999999
      }
    })
  ],

  data() {
    return {
      columns: [
        {
          key: 'name',
          name: '关键字',
          minWidth: this.$col.b
        },
        {
          key: 'sort',
          name: '排序',
          width: this.$col.m
        },
        {
          key: 'isShow',
          name: '状态',
          width: this.$col.m,
          type: 'tag',
          fetchTagType: val => (val ? 'success' : 'info'),
          tagName: row => (row.isShow ? '显示' : '隐藏')
        },
        {
          key: 'action',
          name: '操作',
          width: '120',
          render: (h, { row }) => {
            const action = [];
            action.push(
              h(
                'el-button',
                {
                  props: {
                    type: 'text'
                  },
                  on: {
                    click: () =>
                      this.$TrendItemModal({
                        id: row.id,
                        info: {
                          name: row.name,
                          sort: row.sort,
                          isShow: row.isShow
                        }
                      })
                  }
                },
                '编辑'
              )
            );
            action.push(
              h(
                'BaseBtn',
                {
                  props: {
                    popip: true,
                    txt: '删除',
                    type: 'text'
                  },
                  class: 'ml-10',
                  on: {
                    ok: () => this.handleDelItem(row)
                  }
                },
                '删除'
              )
            );

            return h('div', action);
          }
        }
      ]
    };
  },

  created() {
    this.$g_on('trend_reload', this.reload);
  },

  beforeDestroy() {
    this.$g_off('trend_reload', this.reload);
  },

  methods: {
    handleAdd() {
      this.$TrendItemModal();
    },
    async handleDelItem(item) {
      const { success, msg } = await delItem({
        id: item.id
      });
      if (success) {
        this.$success('删除成功！');
        this.$g_emit('trend_reload');
      }
    }
  }
};
</script>

<style type="scss" scoped></style>
